package ch.epfl.ppo.generators;

import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.Image;

public final class BullseyeGenerator implements Image<ColorRGB> {
    private final ColorRGB color1, color2;
    private final double stripeWidth;

    public BullseyeGenerator(ColorRGB color1, ColorRGB color2, double stripeWidth) {
        if (! (stripeWidth > 0.0))
            throw new IllegalArgumentException("invalid stripe width: " + stripeWidth);

        this.color1 = color1;
        this.color2 = color2;
        this.stripeWidth = stripeWidth;
    }

    @Override
    public ColorRGB valueAt(double x, double y) {
        double r = Math.sqrt(x * x + y * y);
        return (int)Math.floor(r / stripeWidth) % 2 == 0 ? color1 : color2;
    }
}
