package ch.epfl.ppo.generators;

import ch.epfl.ppo.Image;


public final class LinearHorizontalGradientMask implements Image<Double> {
    private final double leftX, rightX;

    public LinearHorizontalGradientMask(double leftX, double rightX) {
        if (! (leftX < rightX))
            throw new IllegalArgumentException("invalid interval: [" + leftX + ";" + rightX + "]");
        this.leftX = leftX;
        this.rightX = rightX;
    }

    @Override
    public Double valueAt(double x, double y) {
        double clampedX = Math.max(leftX, Math.min(x, rightX));
        return (clampedX - leftX) / (rightX - leftX);
    }
}
