package ch.epfl.ppo.generators;

import ch.epfl.ppo.Animation;
import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.Image;

public final class RainbowAnimation implements Animation<ColorRGB> {
    private final double fR, phiR, fG, phiG, fB, phiB;

    public RainbowAnimation(double fR, double phiR, double fG, double phiG, double fB, double phiB) {
        this.fR = fR;
        this.phiR = phiR;
        this.fG = fG;
        this.phiG = phiG;
        this.fB = fB;
        this.phiB = phiB;
    }

    @Override
    public Image<ColorRGB> imageAt(double time) {
        double r = sine(fR, phiR, time);
        double g = sine(fG, phiG, time);
        double b = sine(fB, phiB, time);
        return new ConstantImage<>(new ColorRGB(r, g, b));
    }

    private static double sine(double f, double phi, double t) {
        return Math.sin(t * f * 2.0 * Math.PI + phi) / 2.0 + 0.5;
    }
}
