package ch.epfl.ppo.transformers;

import ch.epfl.ppo.Animation;
import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.Image;

public final class AnimationCompositor implements Animation<ColorRGB> {
    private final Animation<ColorRGB> bg, fg;
    private final Animation<Double> mask;

    public AnimationCompositor(Animation<ColorRGB> bg, Animation<ColorRGB> fg, Animation<Double> mask) {
        this.bg = bg;
        this.fg = fg;
        this.mask = mask;
    }

    @Override
    public Image<ColorRGB> imageAt(double time) {
        return new ImageCompositor(bg.imageAt(time), fg.imageAt(time), mask.imageAt(time));
    }
}
