package ch.epfl.ppo.transformers;

import ch.epfl.ppo.Animation;
import ch.epfl.ppo.Image;

public final class AnimationLooper<T> implements Animation<T> {
    private final double t1, t2;
    private final Animation<T> a;

    public AnimationLooper(double t1, double t2, Animation<T> a) {
        if (! (0 <= t1 && t1 < t2))
            throw new IllegalArgumentException("invalid time interval: [" + t1 + ";" + t2 + "]");
        this.t1 = t1;
        this.t2 = t2;
        this.a = a;
    }

    @Override
    public Image<T> imageAt(double time) {
        return a.imageAt(t1 + time % (t2 - t1));
    }
}
