package ch.epfl.ppo.transformers;

import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.Image;

public final class ImageCompositor implements Image<ColorRGB> {
    private final Image<ColorRGB> background, foreground;
    private final Image<Double> mask;

    public ImageCompositor(Image<ColorRGB> background, Image<ColorRGB> foreground, Image<Double> mask) {
        this.background = background;
        this.foreground = foreground;
        this.mask = mask;
    }

    @Override
    public ColorRGB valueAt(double x, double y) {
        ColorRGB backgroundC = background.valueAt(x, y);
        ColorRGB foregroundC = foreground.valueAt(x, y);
        double amount = mask.valueAt(x, y);
        return backgroundC.mixWith(foregroundC, amount);
    }
}
