package ch.epfl.ppo.transformers;

import ch.epfl.ppo.Image;

public final class RotationTransformer<T> implements Image<T> {
    private final Image<T> imageToRotate;
    private final double angle;

    public RotationTransformer(Image<T> imageToRotate, double angle) {
        this.imageToRotate = imageToRotate;
        this.angle = angle;
    }

    @Override
    public T valueAt(double x, double y) {
        double rX = x * Math.cos(-angle) - y * Math.sin(-angle);
        double rY = x * Math.sin(-angle) + y * Math.cos(-angle);
        return imageToRotate.valueAt(rX, rY);
    }
}
